import * as React from 'react';
export interface IThemeProps<TTheme> {
    theme: TTheme;
}
export declare type IStyleFunction<TTheme, TStylesProps extends IThemeProps<TTheme>, TStyles> = (props: TStylesProps) => TStyles;
export declare type IStateProps<TProps> = TProps & {
    view: (props: TProps) => JSX.Element;
};
export declare type IStylesProp<TTheme, TProps extends IThemeProps<TTheme>, TStyles> = IStyleFunction<TTheme, TProps, TStyles> | TStyles;
export declare type IViewProps<TProps, TStylesSet> = TProps & {
    styles: TStylesSet;
};
export interface IAugmentations<TUserProps extends IThemeProps<TTheme>, TStyles, TStyleSet, TTheme> {
    [scope: string]: IComponentOptions<TUserProps, TStyles, TStyleSet, TTheme>;
}
export interface IComponentOptions<TUserProps, TStyles, TStyleSet, TTheme> {
    scope: string;
    state?: React.ComponentType<IStateProps<TUserProps>>;
    styles: IStylesProp<TTheme, TUserProps & IThemeProps<TTheme>, TStyles>;
    view: React.ComponentType<IViewProps<TUserProps, TStyleSet>>;
}
export interface IStylingProviders<TTheme, TStyles, TStyleSet> {
    getTheme: () => TTheme;
    mergeStyleSets: (styles: TStyles) => TStyleSet;
}
export declare function createComponentWithProviders<TProps, TStyles, TStyleSet, TTheme>(options: IComponentOptions<TProps, TStyles, TStyleSet, TTheme>, providers: IStylingProviders<TTheme, TStyles, TStyleSet>): React.StatelessComponent<TProps>;
export declare function augmentComponent<TProps, TStyles, TStyleSet, TTheme>(options: IComponentOptions<TProps, TStyles, TStyleSet, TTheme>): void;
